function dataHandler () {
  console.log('handler called...')
  if (!this.$data._chart) {
    console.log('redering chart...')
    this.renderChart(this.chartData, this.options)
  } else if (!this._updatingChart) {
    console.log('unWatching...')
    this._unWatchChartData()
    console.log('updating...')
    this.$data._chart.update()
    console.log('watching...')
    this._watchChartData()
  }
}

export const reactiveData = {
  data () {
    return {
      _unWatchChartData: null,
      _updatingChart: false,
      chartData: null
    }
  },
  mounted () {
    this._watchChartData()
  },
  methods: {
    _watchChartData () {
      let firstWatch = true
      this._unWatchChartData = this.$watch('chartData', () => {
        if (firstWatch) {
          console.log('first call... skipping')
          firstWatch = false
        } else {
          dataHandler.call(this)
        }
      }, {
        deep: true
      })
    }
  }
}

export const reactiveProp = {
  data () {
    return {
      _unWatchChartData: null,
      _updatingChart: false
    }
  },
  props: {
    chartData: {
      required: true
    }
  },
  mounted () {
    this._watchChartData()
  },
  methods: {
    _watchChartData () {
      let firstWatch = true
      this._unWatchChartData = this.$watch('chartData', () => {
        if (firstWatch) {
          console.log('first call... skipping')
          firstWatch = false
        } else {
          dataHandler.call(this)
        }
      }, {
        deep: true
      })
    }
  }
}

export default {
  reactiveData,
  reactiveProp
}
